/* Listing2:  Clemens Marschner, 1994
 * Ein einfaches Funktions-Template  */

#include <exec/types.h> // fr BOOL
#include <string.h>     // fr strcmp()
#include <stream.h>     // fr cout

// Maximum-Funktion: Gibt den greren Wert zurck

template <class T>  // T ist ein beliebiger Platzhalter.
inline T Max(T a, T b) { return (a > b ? a : b); }

// Max kann fr alle Typen verwendet werden, die fr den 
// Operator ">" eine berladene Funktion bereitstellen.
// Damit ein Zeiger, z.B. char*, nicht einfach als
// Zeigerwert verglichen wird, sondern dessen Inhalt, 
// mu man das Funktions-Template berladen
// Diese Definition hat Vorrang vor dem Template

inline char *Max(char *a, char *b)
{
    return (strcmp(a,b) > 0 ? a : b);
}

void main() {
    char *a = "Peter";
    char *b = "Meyer";
    int c = 38, d = 18;
    cout << Max(a, b) << ", " << Max(c, d) << "\n";
    // Ausgabe: Peter,38
    // cout << Max(a, c); ergbe einen Fehler
}

